# Record Class CLNVersion

java.lang.Object
java.lang.Record
com.io7m.calino.api.CLNVersion

Record Components:
  `major` - The major version
  `minor` - The minor version

All Implemented Interfaces:
  `Comparable<CLNVersion>`

public record CLNVersion(int major, int minor) extends Record implements Comparable<CLNVersion>
A version number.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Pattern`
  `VALID_VERSION`
  The pattern that defines a valid version.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CLNVersion(int major, int minor)`
  Creates an instance of a `CLNVersion` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CLNVersion other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `int`
  `major()`
  Returns the value of the `major` record component.
  `int`
  `minor()`
  Returns the value of the `minor` record component.
  `static CLNVersion`
  `parse(String text)`
  Parse a version string.
  `String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### VALID_VERSION

    public static final Pattern VALID_VERSION
    The pattern that defines a valid version.

- ## Constructor Details

  - ### CLNVersion

    public CLNVersion(int major, int minor)
    Creates an instance of a `CLNVersion` record class.
    Parameters:
      `major` - the value for the `major` record component
      `minor` - the value for the `minor` record component

- ## Method Details

  - ### parse

    public static CLNVersion parse(String text) throws ParseException
    Parse a version string.
    Parameters:
      `text` - The text
    Returns:
      A version string
    Throws:
      `ParseException` - On parse errors

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### compareTo

    public int compareTo(CLNVersion other)
    Specified by:
      `compareTo` in interface `Comparable<CLNVersion>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### major

    public int major()
    Returns the value of the `major` record component.
    Returns:
      the value of the `major` record component

  - ### minor

    public int minor()
    Returns the value of the `minor` record component.
    Returns:
      the value of the `minor` record component